; From  Hugh Noland - dividing by 10
;
;---------------------------------------------------------------------------
;This procedure divides the number in AX by 10, using only
;shift, add, and subtract instructions.  It is based on the
;equality  1/10 = 1/2^3 - 1/2^5 + 1/2^7 - 1/2^9 + ...
;The quotient is returned in AX and the remainder in DX.
;Other registers are preserved.
;---------------------------------------------------------------------------
div10   proc
   push bx
   push cx
   push si
   push di
   mov di,ax                     ;save AX
   mov bx,ax
   mov si,1                      ;add or subtract according as SI = 1 or 0
   cmp ax,0
   je quo_0                      ;if AX = 0, not much to do
   xor dx,dx
   mov cl,3
   shr ax,cl                     ;divide by 2^3
   cmp ax,0                      ;if AX < 8, not much to do
   je quo_1
   mov bx,ax                     ;BX will hold quotient after loop
   mov cl,2
b0:
   shr ax,cl                     ;divide by 2^2
   cmp ax,0                      ;loop finished when AX = 0
   je quo_2
   xor si,1
   cmp si,1
   jnz minus
   add bx,ax
   jmp b0
minus:
   sub bx,ax
   jmp b0
 
quo_0:                           ;quotient and remainder both = 0
   mov dx,0
   pop di
   pop si
   pop cx
   pop bx
   ret
quo_1:                           ;quotient = 0, remainder = original number
   mov dx,bx
   pop di
   pop si
   pop cx
   pop bx
   ret
quo_2:                           ;quotient != 0
   mov ax,bx                     ;to get remainder, multiply quotient
   mov cx,10                     ;by 10 and subtract result from
   mul cx                        ;original number
   sub di,ax                     ;
   mov dx,di                     ;put remainder in dx
   mov ax,bx                     ;put quotient in AX
   pop di
   pop si
   pop dx
   pop bx
   ret
div10   endp
